/******************************************************************************/
// modul: about.h   version 1.0b (english)                                    //
//                                                                            //
//    an about dialog with a few lines of text and an icon playing pinball    //
//		with the dialogs frame.                                                //
//                                                                            //
//    written by lore@newty.de   -   home: www.newty.de                       //
//    copyright 1999-2000 by lore                                             //
//                                                                            //
//    FREE for all kinds of non-commercial use including modifying and        //
//    redistribution as long, as this header is not removed!                  //
//    disclaimer: nothing is guaranteed. you use it on your own risk.         //
//                                                                            //
/******************************************************************************/


#ifndef _ABOUT_H
#define _ABOUT_H


#include <owl\owlpch.h>
#include <owl\static.h>		// due to: TStatic


/***********************************************************************************************************/
// class for a window containing an icon. this window can be moved in its parents client area without
// permanent redraw of the icon.
class TIconWnd : public TWindow
{
public:
	TIconWnd(TWindow* _parent, TIcon* _icon2Draw);

	void moveIcon(const int x, const int y) { MoveWindow(x, y, 32, 32, true); };

	void drawIcon(TIcon* _icon2Draw)
    		  	{ TClientDC dc(*this); 	icon2Draw = _icon2Draw; dc.DrawIcon(0, 0, *icon2Draw);	};

private:
	TIcon* icon2Draw;
	void Paint(TDC& dc, bool erase, TRect& rect) 	{ dc.DrawIcon(0, 0, *icon2Draw); };
};



/***********************************************************************************************************/
// class for an about-dialog with an icon playing pinball with the dialogs frame.
//	despite the name this class derives from TWindow!
class TAbout : public TWindow
{
public:
	TAbout::TAbout(TWindow* _parent, const char* title, const TFont* _font);
   TAbout::~TAbout();

   void SetupWindow();
	void setText(int row, const char* text);     // set the texts of the dialogs static-textfields
   void EvTimer(unsigned int id);

private:

	const TFont* font;

   TIcon* 		icon1, *icon2, *icon2Draw;			// -> icons
   TIconWnd* 	smiley;									// -> icon-window


   int 	nSmileTime;
   float xIcon, yIcon;                          // icon-window position and moving direction
   float directionPhi;

   TStatic* row1, *row2, *row3, *row4;			 	// the four static textfields

	DECLARE_RESPONSE_TABLE(TAbout);
};


#endif
