/******************************************************************************/
// modul: testBed.cpp  version 1.0b (english)                                 //
//                                                                            //
//   testbed for the the classes: TAbout, TThreadCtrlDialog and TAsciiData    //
//   see header-file for further information and disclaimer.                  //
/******************************************************************************/




#define IPI "insufficient programmers intelligence: program will be terminated"


#include <dir.h>						// due to: 	getcwd()
#include <stdio.h> 					// 			sprintf()
#include <owl\opensave.h> 			// 			TOpenSaveDialog
#include <owl\owlpch.h>


#include "main.h"
#include "main.rh"


static const char* prgName 		= "testBed 1.0b";		// programs name



/***********************************************************************************************************/
// response table of main window
DEFINE_RESPONSE_TABLE1(mainWnd,TWindow)
   EV_COMMAND(CM_DATA_DEMO,	CmDataDemo),      // demonstrate TAsciiData
	EV_COMMAND(CM_THREAD_DEMO, CmThreadDemo),		// 	  "		TThreadCtrlDlg
   EV_COMMAND(CM_ABOUT,			CmAbout),			// 	  "		TAbout
END_RESPONSE_TABLE;



/***********************************************************************************************************/
// constructor and destructor
mainWnd::mainWnd() : TWindow(0,0,0)
{ font = new TFont(CreateFont( -20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, TEXT("Arial"))); }	// create font

mainWnd::~mainWnd() { delete font; }																			// delete font




	/****************************************************/
   //
   //  usage of thread-control-dialog TThreadCtrlDlg
   //


#include <process.h>					// due to: _beginthread()
#include "threadCtrlDlg.h"


////////////////////////////////////////////////////////////////////////////////////////
// function which is to be called by the thread-control dialog periodically
void dispState(void* _dialog)
{
 	TThreadCtrlDlg* dialog = (TThreadCtrlDlg*) _dialog;	// explicit typecast
   dialog->setGauge(dialog->progress);							// just set the gauge
}


////////////////////////////////////////////////////////////////////////////////////////
// thread-function: this functions contains the code you want to be executed in an
// additional thread.
void threadFunc(void* _dialog)
{
	TThreadCtrlDlg* dialog = (TThreadCtrlDlg*) _dialog;	// explicit typecast


	// pass a pointer to the stop-flag to the dialog
   bool stop=false;
   dialog->setStopFlag(&stop);



   // calculate something - note: this loops runs 100 times
   do
   {
		Sleep(100);				 // calculation is emulated by a sleep-command which stops the thread for 0.1s
      dialog->progress++;   // increment progress-counter

      if(stop)       		 // check stop-flag and if true: immediately leave the loop
      	break;

   } while(dialog->progress<100);


   // end dialog and exit the thread by exiting the function
   dialog->shutDown();
}



/***********************************************************************************************************/
// function shows how to execute threadFunc() in an additional thread.
void mainWnd::CmThreadDemo()
{
// I. example how to execute modal

   // a) instantiate a thread-control dialog with buttons
   TThreadCtrlDlg* pCtrlDlg = new TThreadCtrlDlg(this, "testing thread-control dialog",  IDD_DIALOG, font, true);


   // b) set first text-field and callback-function
   pCtrlDlg->setText1("performing modal");
   pCtrlDlg->setCallbackFunc(dispState, (void*) pCtrlDlg, /* call every 0.25 seconds = */ 250);


   // c) start additional thread using _beginthread(): the function 'threadFunc' will be called and the pointer
   //    'pCtrlDlg' will be passed to it as a void-pointer.
   _beginthread(/*pointer to thread-function*/ threadFunc, 4096, /*pointer to argument-list*/(void*) pCtrlDlg);


   // d) execute thread-control dialog modal. note: the additional thread is already running at this moment
   int returnValue=pCtrlDlg->Execute();
   int actualState=pCtrlDlg->progress;	// remember dialogs state for eventual later use

   // e) delete thread-control dialog
	delete pCtrlDlg;



 // II. example how to execute none-modal - note: this code is executed if the user hits the 'background'-button
 //     during the modal execution in I.
	if(returnValue==ID_BKGND)
	{
		// a) instantiate a thread-control dialog without buttons
      // 	IMPORTANT: do not use the dialog twice! it is not implemented for this kind of use. you would cause
      //               a lot of problems otherwise: one prob is, that the Execute()-function is left before(!)
      //               the function ShutDown() is left in your additional thread. thus you may come up to this
      //					  point here while there is still some code executed in your additional thread.
   	TThreadCtrlDlg* pCtrlDlg = new TThreadCtrlDlg(this, "testing thread-control dialog",  IDD_DIALOG, font);


		// b) set first and second text-field and set callback-function
	   pCtrlDlg->setText1("performing in the background ...");
	   pCtrlDlg->setText2("... and without any buttons");
	   pCtrlDlg->setCallbackFunc(dispState, (void*) pCtrlDlg, /* call every 0.25 seconds = */ 250);


      // c) start additional thread - note: the same thread-function is used as for modal execution.
   	_beginthread(threadFunc, 4096, (void*) pCtrlDlg);


      // d) set flag, actual state (progress) and create dialog-window
      pCtrlDlg->SetFlag(wfDeleteOnClose);					// dialog will be deleted when it is closed
      pCtrlDlg->progress=actualState;
      pCtrlDlg->Create();
   }
}



	/****************************************************/
   //
   //  usage of "load ASCII data from file"-class
   //


#include "asciidata.h"


/***********************************************************************************************************/
// load a file named "test.dat" and do some things with it ...
void mainWnd::CmDataDemo()
{
	// a) create TAsciiData object
	TAsciiData* data = new TAsciiData(this, font, IDD_DIALOG);

   // b) read data - note: reading can cause an exception. thus encapsulate all in a try-block
	try
   {
  		data->load("test.dat"); 		//	load data - this file must exist
	   data->calc();						// calculate statistical values
   }
   catch(TErrText err)
   {
     	MessageBox(err.szErrText, "error loading test.dat", MB_OK | MB_ICONERROR);
   }


  // c) check success
	if(data->dim() == 0 || data->nDS() == 0)	// if data-matrix has zero rows or columns -> ...
  	{
   	data->release();		// ... release it again
      return;
   }


  // d) do something with the data - note: encapsulated in a try-block cause exceptions could be thrown
	try
   {
	  // how to access the data - example: calculate the sum of each column
     // IMPORTANT: all countig starts up with zero. thus the first row has the index 0.
		double* sum = new double[data->dim()];					// allocate memory for the sums

		for(int i=0;i<data->nDS();i++)  							// over all rows
   	{
			const float* row = data->getRow(i);					// get pointer to i-ths row

         for(int j=0;j<data->dim();j++)                  // over of columns of the actual row ...
         	sum[j]+=row[j];											// ... sum up
      }


      // display the sum of the first column and release 'sum'
      char szText[256];
      sprintf(szText, "The sum of the first column is: %f", sum[0]);
      MessageBox(szText);

      delete[] sum;


     // how to sort, randomize and reorder
		data->sort(0);								// sort rows regarding column 0, i.g. the first column
		data->save("sort.dat");             // save

      data->randomize(4*data->nDS());     // randomize all rows
	   data->save("rand.dat");					// save

	   data->reorder();    						// restore original order
		data->save("original.dat");			// save

	 	data->release();                    // release
   }
   catch(TErrText err)
   {
     	MessageBox(err.szErrText, "error:", MB_OK | MB_ICONERROR);
   }
}



   /****************************************************/
	//
   //  usage of about-dialog TAbout
   //


#include "about.h"


/***********************************************************************************************************/
// display about dialog
void mainWnd::CmAbout()
{
	TAbout* about = new TAbout(this, "About the program", font);			// new dialog and ...
   about->Create();                                                     // ... create it

   // set the static text-fields of the dialog
   char szText[256];
   sprintf(szText, "%s    - powered by Borland c++ 5.02", prgName);
   about->setText(1, szText);
	about->setText(2, "testbed for TThreadCtrlDlg, TAsciiData and TAbout");
	about->setText(3, "written by lore@newty.de");
	about->setText(4, "free for all kinds of non-commercial use");

   about->SetFlag(wfDeleteOnClose);		// set flag: dialog is deleted, when it is closed
}



/***********************************************************************************************************/
// main-application
class mainApp : public TApplication
{
 public:
	mainApp() : TApplication() {};
   void InitMainWindow()
   {
   	MainWindow = new TFrameWindow(0, prgName, new mainWnd());

      // assign icon/menu and center window
      MainWindow->SetIcon	(this, IDI_TESTBED);
		MainWindow->SetIconSm(this, IDI_TESTBED);
      MainWindow->AssignMenu(IDM_MENU);
   	MainWindow->MoveWindow((GetSystemMetrics(SM_CXSCREEN)-100)/2, (GetSystemMetrics(SM_CYSCREEN)-150)/2,
      																										350, 150, true);
   }

   virtual int Run();	// see comments below
};


/***********************************************************************************************************/
// annotation: when debugging under win95 the catching of the exceptions doesnt work. in the compiled
// executable everything is fine.
int mainApp::Run()
{
	int tmp=0;

   // ipi - exception handling (ipi = insufficient programmers intelligence:-)
   // i always get this error when i least expect it :-))
  	try
   {
     	tmp=TApplication::Run();
   }
   catch(TErrText err) { MainWindow->MessageBox(err.szErrText			, IPI, MB_OK | MB_ICONERROR); }
   catch(...)			  { MainWindow->MessageBox("unknown exception"	, IPI, MB_OK | MB_ICONERROR); }

   return tmp;
}


/***********************************************************************************************************/
// starting point
int OwlMain(int, char**){	return mainApp().Run(); }




